## Introduction

A "zipper" table is a database table typically used to associate the keys of two tables, so that the association can be determined using either key.
The Zipper module provides a UI with which a "Zipper table" can be described and created for use in other modules.

An example use case for this module is a table containing teachers and a table containing classrooms.

| Teacher | Classroom |
|---------|-----------|
| 13542   | AH-132    |
| 02415   | PH-201    |

A zipper table would hold a record for each teacher/classroom pairing, where the teacher could be retrieved to find the classroom, or vice versa.

## Features
* A form to provide the table specifics
    * Table name
    * Description
    * Key 1 field name
    * Key 1 field type (numeric/text)
    * Key 2 field name
    * Key 2 field type (numeric/text)
    * Key relationship (1:1, 1:many)
* Zipper tables management View
    * All table details
    * Edit link for table details
    * Truncate (empty) link
    * Delete link
    * A link to truncate all Zipper tables
    * A link to delete all Zipper tables
* API that allows the following retrievals
    * By key 1[^1]
    * By key 2[^1]
    * By key 1 **AND** key 2
* All records in the table

[^1]If a 1:many table all matching records will be returned

## Requirements
This module has no specific requirements.

## Installation
Install as you would normally install a contributed Drupal module.
See: https://www.drupal.org/node/895232 for further information.

If your project is managed by composer

`composer require drupal/zipper`

**Uninstalling the module will result in the zipper data table and all Zipper tables being removed.**

## Configuration
The module has no menu or modifiable settings. There is no configuration.

## Using the module
The URLs are:

Management page: /admin/config/development/zipper
Add Zipper table: /admin/config/development/zipper/add

## Supporting Organizations
[The Accidental Coder](https://theaccidentalcoder.com)
Provides equipment, coffee and pizza.

## Maintainers

Current maintainers for Drupal 10:

- [Jeff Greenberg - j. ayen green](https://www.drupal.org/u/j-ayen-green)

