<?php

namespace Drupal\zipper\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\Core\Url;

class ZipperApi extends ControllerBase {

  public function get($zid = NULL, $table = NULL): bool|array {

    // Must have either zid or table name.
    if ($zid || $table) {
      $db = \Drupal::database();
      $where = "";
      $all = $zid === "ALL";
      if ($table && $table & !$all) {
        $where = "WHERE ";
        $where .= $zid ? "zid=$zid" : "name=$table";
      }
      $result = $db->query("SELECT * FROM zipper $where");
      if ($result) {
        if (!$all) {
          return $result->fetchAssoc();
        }
        else {
          foreach ($result as $record) {
            $records[] = $record;
          }
          return $records;
        }
      }
    }

    return FALSE;
  }

  public function getData($table, $key1, $key2, $key1Value = NULL, $key2Value = NULL): bool|array {
    /*
    The logic for data retrieval query is:
    key1    key2
    x       y       where key1 = x and key2 = y
    x       ø       where key1 = x
    ø       y       where key2 = y
    ø       ø       U
     */
    $where = ($key1Value || $key2Value) ? "WHERE " : '';
    if ($where) {
      $where .= ($key1Value) ? "$key1='$key1Value'" : '';
      $where .= ($key1Value && $key2Value) ? " AND " : '';
      $where .= ($key2Value) ? "$key2='$key2Value'" : '';
    }
    $db = \Drupal::database();
    $result = $db->query("SELECT * FROM $table $where");
    if ($result) {
      $recs = [];
      foreach ($result as $record) {
        $recs[] = $record;
      }
    }

    return $result ? $recs : FALSE;
  }

  public function delete($name): RedirectResponse {

    $db = \Drupal::database();
    $zipper = new ZipperApi();

    $all = $name === "ALL";
    if ($name === "ALL") {
      $tables = $zipper->get('ALL');
      foreach ($tables as $table) {
        $name = $table->name;
        $db->query("DROP TABLE $name");
        $db->query("DELETE FROM zipper WHERE name='$name'");
      }
    }
    else {
      $result = $db->query("DROP TABLE $name");
      $result = $db->query("DELETE FROM zipper WHERE name='$name'");
    }

    $url = Url::fromRoute('zipper')->toString();
    return new RedirectResponse($url);
  }

  public function truncate($name): RedirectResponse {

    $db = \Drupal::database();
    $zipper = new ZipperApi();

    $all = $name === "ALL";
    if ($name === "ALL") {
      $tables = $zipper->get('ALL');
      foreach ($tables as $table) {
        $name = $table->name;
        $result = $db->query("DELETE FROM $name");
      }
    }
    else {
      $result = $db->query("DELETE FROM $name");
    }

    $url = Url::fromRoute('zipper')->toString();
    return new RedirectResponse($url);
  }

}
