<?php

namespace Drupal\zipper;

class Zipper {

  public function get($table=NULL, $zid=NULL, $key1=NULL, $key2=NULL): false|array {

    // The user can choose to identify the Zipper table by name or by zid.
    if (!$table && !$zid) {
      return FALSE;
    }

    $zipper = new ZipperApi();
    // Get the key info from the Zipper table.
    $result = $zipper->get($zid, $table);
    if (!$result) {
      return FALSE;
    }

    return $result;
  }

  /**
   * @throws \Exception
   */
  public function createTable($values): void {

    $db = \Drupal::database();
    $db->insert('zipper')
      ->fields([
        'name' => $values['table_name'],
        'description' => $values['table_desc'],
        'key1' => $values['field1'],
        'key_type1' => $values['field1_type'],
        'key2' => $values['field2'],
        'key_type2' => $values['field2_type'],
        'relationship' => $values['table_type'],
      ])
      ->execute();

  }

}
